# Gemini CI
## Introduction
`gem-ci` is used to create RPM repositories associated with branch names in a specific format
and to create docker containers as an in-situ development and deployment environment to work
on further modules, e.g. epics support modules. 

The RPM repositories and docker containers are organized in three layers:
1. the `common ` layer which contains programs like `procServ`, `tdct` and `gemini-ade` which are used
in all containers
2. the `epics-base` layer, containing `rtems`, `epics-base` and (per default) all EPICS support modules
3. the `app` or `ioc` layer, containing modules specific to an EPICS `IOC`

The `epics-base` layer is using the `common` container as a base, including all repository information from
it, also for the included `tito` and/or `mock` programs used to build and deploy RPMs into the refering repositories.
The `app` layer is using the `epics-base` container as a base, hence including all RPM repository information
from `epics-base` and `common`.

## Basic usage
The determinator if to build RPMs and to what repository it would be deployed to is the _branch name_ and the _layer_ the respective
project is classified to. While the classification of layers is handled by `gem-ci` based on the project's subgroup, the 
branch name needs to be chosen by the developers. It has to follow a 
specific pattern:
- `unstable/<someName>` for unstable releases
- `testing/<someName>` for testing releases
- `stable/<someName>` for stable releases

`<someName>` will very probably be limited to the regular expression '20[2-9][0-9]q[0-4]*' (or similar) to enforce a quarterly
release cycle. **Note that the branch names need to be identical across all projects which RPMs should end up in one repository**.

As soon as such a branch is pushed, a RPM will be generated by `tito` and deployed to a repository associated with the branch name.
After successful deployment, a associated container is (re)built and can be used for development after pulling.

## Workflow for EPICS support modules
A typical workflow for a support module would look like the following:
```
# delete the potentially alread existing epics-base container
docker container rm -f <ID of epics-base-testing-2021q4>
# pull the newest image of it
docker image pull registry.gitlab.com/nsf-noirlab/gemini/rtsw/epics-base/epics-base/testing/2021q4:latest
# start your epics-base container
docker run -d --restart always --cap-add=SYS_ADMIN --name epics-base-testing-2021q4  --hostname epics-base-testing-2021q4-CONTAINER --tmpfs /tmp --tmpfs /run -v /home:/home -v /gem_test:/gem_test -v /gem_base/epics -v /etc/passwd:/etc/passwd:ro -v /etc/group:/etc/group:ro -v /etc/shadow:/etc/shadow:ro -v /etc/sudoers:/etc/sudoers:ro -v /etc/sudoers.d:/etc/sudoers.d:ro -v /etc/gshadow:/etc/gshadow:ro -v /sys/fs/cgroup:/sys/fs/cgroup:ro -v /var/lib/sss/:/var/lib/sss/:ro -v /var/lib/sss/pipes/:/var/lib/sss/pipes/:rw registry.gitlab.com/nsf-noirlab/gemini/rtsw/epics-base/epics-base/testing/2021q4:latest

# change into the support modules directory
cd workbench/mySupportModule
# checkout your working branch
git checkout myWorkingBranch
# rebase you current working branch to master
git rebase master
# create unstable branch for next quarterly release
git checkout -b unstable/2021q4

# upgrade gem-ci if neccessary
# git submodule updated --init --remote gem-ci
# OR overwrite the existing, maybe outdated configuration globally
# gem-init-project.sh -f

# commit changes
git commit -am"my commit message"
# ... and push it to the remote
git push --set-upstream origin unstable/2021q4
```

The pipeline is triggered, should automatically choose the right container based on the branch name and deploy a new container with `mySupportmodule` being readily installed amongst all other RPMs from the epics-base yum repository.

After some testing work, the following workflow might be done:
```
# being on unstable/2021q4, rebase to master
git checkout unstable/2021q4
git rebase master
# push changes to remote
git push

# create a merge request from the URL shown in the 'git push' dialog

# After the fast-forward merge was done, checkout master
git checkout master
# and pull the latest changes
git pull

# create a testing release
git checkout -b testing/2021q4
# and push it to the remote
git push --set-upstream origin unstable/2021q4
```

The pipeline should be triggered and create a new epics-base testing container with `mySupportModule` RPMs being readily installed.
